/*------------------------------------------------*/
/* c34/adresar.c                                  */
#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <errno.h>

#ifdef __unix__
	#include <unistd.h>
	#include <sys/stat.h>
	#include <sys/types.h>
#elif defined _MSC_VER
	#include <direct.h>
#else
	#include <dir.h>
#endif

#define ADRESAR "DATADIR"
#define SOUBOR  "ahoj.txt"

#ifdef __unix__
	#define GETCWD(X, I) getcwd(X, I)
	#define MKDIR(X) mkdir(X, 0777)
	#define CHDIR(X) chdir(X)
	#define UNLINK(X) unlink(X)
	#define RMDIR(X) rmdir(X)
#elif defined _MSC_VER
	#define GETCWD(X, I) _getcwd(X, I)
	#define MKDIR(X) _mkdir(X)
	#define CHDIR(X) _chdir(X)
	#define UNLINK(X) _unlink(X)
	#define RMDIR(X) _rmdir(X)
#else
	#define GETCWD(X, I) getcwd(X, I)
	#define MKDIR(X) mkdir(X)
	#define CHDIR(X) chdir(X)
	#define UNLINK(X) unlink(X)
	#define RMDIR(X) rmdir(X)
#endif

int errkonec(void)
{
    perror("CHYBA");
    fprintf(stderr, "Stisknete ENTER pro ukonceni ...\n");
    (void) getchar();
    return errno;
}

int main(void)
{
    char text[255];
    FILE *soubor;
    char c;

    GETCWD(text, sizeof(text) / sizeof(text[0]));
    printf("Vytvarim v adresari %s podadresar %s\n", text, ADRESAR);


    if (MKDIR(ADRESAR) != 0) {
	return errkonec();
    }

    printf("Vstupuji do adresare %s\n", ADRESAR);
    if (CHDIR(ADRESAR) != 0) {
	return errkonec();
    }

    printf("Vytvarim soubor %s\n", SOUBOR);

    if (!(soubor = fopen(SOUBOR, "w+")))
	return errkonec();

    fprintf(soubor, "Ahoj");
    fclose(soubor);
    printf("Mam zase vse smazat? [y/n] ");
    c = getchar();
    if (c == 'n') {
	fputs("Koncim.", stdin);
	return 0;
    } else if (c != 'y') {
	fputs("Nechapu, koncim.", stdin);
	return 0;
    }

    /* mazani souboru a adresare */
    printf("Mazu soubor %s\n", SOUBOR);
    if (UNLINK(SOUBOR) != 0) {
	return errkonec();
    }

    printf("Opoustim adresar %s\n", ADRESAR);
    /* prechod v adresarove strukture o adresar vyse */
    if (CHDIR("..") != 0) {
	return errkonec();
    }

    printf("Mazu adresar %s\n", ADRESAR);
    if (RMDIR(ADRESAR) != 0) {
	return errkonec();
    }

    return 0;
}

/*------------------------------------------------*/
